/* ==== combat.c ==== */
/* Uh... what'll we do here? */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "porrog_defs.h"
#include "C-foogrid.h"
#include "item_t.h"
#include "structures.h"
#include "mapgen_types.h"
#include "player_t.h"
/* protos */
#include "monster.h"
#include "ui.h"
#include "combat.h"
#ifdef AUTOPILOT
#include   "mg_utils.h"
#endif


/* Don't need to state map any more ! */
void p_hit_m(monster_t *target)
{
    /* For now, we just assume player always hits
    and removes 1 HP from target */
    target->Var_stats.Hp--;
    sprintf(strbuf,"You hit the %s.",target->Mobtype->Name);
    show_messages(strbuf);
    if(target->Var_stats.Hp<0)
    {
       sprintf(strbuf,"You kill the %s!",target->Mobtype->Name);
       show_messages(strbuf);
       m_die(tls, target); /* should be in monster.c */
    }
}

void m_hit_p(monster_t *attacker)
{
#ifdef AUTOPILOT
    int r;
#endif
    /* For now, just assume attacker always hits, removing 1 HP */
    player.Var_stats.Hp--;
    sprintf(strbuf,"The %s hits you.",attacker->Mobtype->Name);
    show_messages(strbuf);
    if(player.Var_stats.Hp<0)
    {
#ifndef AUTOPILOT
       sprintf(strbuf,"The %s kills you!",attacker->Mobtype->Name);
       show_messages(strbuf);
       quit=2; /* 2=dead */
#else
       /* Don't quit, just put the player somewhere else instead */
       player.Var_stats.Hp=player.Var_stats.MaxHp;
       r=pick_room(tls->Totalrooms);
       player.X=tls->Room[r].Xcentre;
       player.Y=tls->Room[r].Ycentre;
#endif
    }
}

void m_hit_m(monster_t *att, monster_t *target)
{
    /* For now, we just assume player always hits
    and removes 1 HP from target */
    target->Var_stats.Hp--;
#ifndef AUTOPILOT
    if (in_los(player.X,player.Y,att->X,att->Y)) {
#else
    if (in_los(tls->Moblist->X,tls->Moblist->Y,att->X,att->Y)) {
#endif
      sprintf(strbuf,"The %s hits the %s.",att->Mobtype->Name,target->Mobtype->Name);
      show_messages(strbuf);
    }
    if(target->Var_stats.Hp<0)
    {
       /* This should be governed by LOS too */
       sprintf(strbuf,"The %s kills the %s!",att->Mobtype->Name,target->Mobtype->Name);
       show_messages(strbuf);
       m_die(tls, target); /* should be in monster.c */
    }
}
